// ---------------------------------------------------------------------------
// 
//   Lily Engine alpha
// 
//   Copyright (c) 2010 Clifford Jolly
//     http://cliffjolly.com
//     cliff@cliffjolly.com
// 
// ---------------------------------------------------------------------------
// 
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//  
//   This program is distributed in the hope that it will be useful, but
//   WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//   General Public License for more details.
// 
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
//   USA
// -------------------------- END HEADER -------------------------------------

#include <vector>

#include "texturemanager.h"
#include "texture.h"

class MetaTexture : public Texture {
	
    public:
	
        MetaTexture(void);
		
        virtual ~MetaTexture(void);
		
        void startLoad(const std::string &fileName);
        void waitForLoad(void);
        bool isLoaded(void);
        void backgroundLoad(void);
        void bindTexture(void);
		
        Image *getOriginalImage(void);

    private:
		
        bool sizesCopied;
        void finishLoad(void);
        std::vector<int> textureDeps;
	
        int vertShaderID;
        int fragShaderID;
        int programID;
		
        bool shaderError;
        vector<int> textureUniforms;

};
